DECLARE SUB info ()
DECLARE SUB Chooseindelning ()
DECLARE SUB ChoseFaktor ()
DECLARE SUB ChooseMeter ()
DECLARE SUB ChooseEnhet ()
DECLARE SUB NumDec (svar$)
DECLARE SUB ritaskala (indelning!, L1!, L2!, g!)
DEFSNG A-Z
DIM SHARED svarTal, svarenhet$, indelning, enhet$, faktor, rightRow, rightTot, wrong, good
'this program is to create a voltmeter reading practice game'
'ge information om programmet
CALL info
SCREEN 8
  CONST PI = 3.141593
g = PI / 180
DO
    IF r$ = "H" OR r$ = "h" THEN CALL info
SCREEN 8
CLS
RANDOMIZE TIMER
CALL ChooseMeter
CIRCLE (320, 160), 300, 4, 45 * g, 135 * g
CIRCLE STEP(0, 0), 200, 3, 40 * g, 140 * g
CIRCLE STEP(0, 0), 210, 3, 40 * g, 140 * g
L1 = 280' inner limit of scale line
L2 = 40'length of scale lines
helskala = faktor * indelning
FOR i% = 0 TO indelning
x1 = 320 + L1 * COS(g * (135 - 90 * i% / indelning))
y1 = 160 - L1 * 125 / 300 * SIN(g * (135 - 90 * i% / indelning))
x2 = L2 * COS(g * (135 - 90 * i% / indelning))
y2 = -L2 * 125 / 300 * SIN(g * (135 - 90 * i% / indelning))
LINE (x1, y1)-STEP(x2, y2)
LOCATE (1 + INT(2 / indelning * 7) * ABS(indelning / 2 - i%)), (10 + i% / indelning * 60)
PRINT i%
NEXT i%


L = 320 'lngden av visaren
del = RND
LOCATE 18, 4
PRINT "Skala = "; helskala; " "; enhet$

LINE (320, 160)-STEP(L * COS(g * (135 - 90 * del)), -L * 125 / 300 * SIN(g * (135 - 90 * del)))
LOCATE 20, 2
CALL NumDec(svar$)

PRINT "Rtt vrde = ";
PRINT USING "###.###"; del * helskala;
PRINT " "; enhet$
PRINT " Error = ";
PRINT USING "###.# "; 100 * ABS(1 - svarTal / (del * helskala));
PRINT "%  eller cirka ";
PRINT USING "###.#"; 130 / helskala * (svarTal - del * helskala);
PRINT " mm p skalan"
IF ABS(130 / helskala * (svarTal - del * helskala)) < 1 THEN
                rightRow = rightRow + 1
                rightTot = rightTot + 1
                COLOR 12, 0
                PRINT "BRA! Mindre n 1mm fel "; rightRow; " gng(er) i rad!"
                COLOR 15, 0
        ELSEIF ABS(130 / helskala * (svarTal - del * helskala)) < 3 THEN
                good = good + 1
                PRINT "Frsk f inom 1mm! Det gr!  MVG hittills: "; rightTot; " G:"; good; " av totalt: "; rightTot + wrong + good
     ELSE
        rightRow = 0
        wrong = wrong + 1
        PRINT "Bttre mste du!  MVG hittills:"; rightTot; " G:"; good; " av totalt: "; rightTot + wrong + good
END IF

INPUT "Redo att fortstta? j/n/h=hjlp (j)", r$
LOOP WHILE r$ = "j" OR r$ = "J" OR r$ = "Y" OR r$ = "y" OR r$ = "" OR r$ = "H" OR r$ = "h"

SYSTEM

SUB ChooseEnhet
     SELECT CASE INT(4 * RND)
       CASE 0
        enhet$ = "V"
       CASE 1
        enhet$ = "mV"
       CASE 2
        enhet$ = "A"
       CASE 3
        enhet$ = "mA"
              END SELECT
END SUB

SUB Chooseindelning
     SELECT CASE INT(4 * RND)
       CASE 0
        indelning = 4
       CASE 1
        indelning = 5
       CASE 2
        indelning = 6
       CASE 3
        indelning = 10
              END SELECT

END SUB

SUB ChooseMeter
'denna subrutin skall slumpa fram skala mtomrde mm
'vlj enhet
CALL ChooseEnhet
'vlj indelning
CALL Chooseindelning
'vlj faktor
CALL ChoseFaktor
END SUB

SUB ChoseFaktor
     SELECT CASE INT(4 * RND)
       CASE 0
        faktor = 1
       CASE 1
        faktor = 2
       CASE 2
        faktor = 10
       CASE 3
        faktor = 10
     END SELECT
END SUB

SUB info
SCREEN 0
CLS
COLOR 9, 0, 7
PRINT
PRINT "               VOLTsEGA.BAS"
PRINT "       TRNING PROGRAM FR AVLSNING AV VISARINSTRUMENT"
PRINT
PRINT " SVENSK Version 970901 TUPO media  Jeff Forssell SSVH jeff_forssell@hotmail.com"
COLOR 7, 0
'PRINT " Om programmet inte visar svenska tecknen  mm har inte GRAFTABL laddats"
'PRINT " G ur programmet och skriv    GRAFTABL   och starta sedan programmet "
'PRINT " VOLTsEGA igen!"
PRINT
PRINT " Kom ihg att skriva enheter med rtt storlek p bokstverna:"
PRINT "     t ex:  MV r megavolt inte millivolt (mV)"
PRINT " Du kan f VERSALER (SOM DESSA)genom att hlla nere"
PRINT " <SHIFT>tangenten (det finns en p varje sida just ver <Ctrl> tangenterna."
PRINT
PRINT " Du kan anvnda . eller , som decimaltecken. Du behver inte ha mellanrum"
PRINT " mellan mtetal och enhet:  2,3V  2.3 V ven 2 ,3  V gr bra men inte 2.3v"
PRINT " (Volt frkortas med V inte v!) Du trycker <Enter> nr du har skrivit svaret."
PRINT
PRINT " Frsk uppskatta vrden s noga du kan. Med trning borde du kunna "
PRINT " f svar som felar mindre n 0,6 mm p skalan. Skrmen i sig kan bara visa med "
PRINT " en nogrannhet av cirka 0,3 mm. "
PRINT
PRINT " Om skalan r t.ex. 20A och hgsta synliga vrdet p skalan r 10, mste"
PRINT " du multiplicera din avlsning med 20/10= 2. Eller 60A resp 6: gngra med 10"
PRINT
PRINT " Om du vill lmna programmet nu (t ex fr att ladda GRAFTABL) "
PRINT " Tryck  L och <ENTER> , annars";
COLOR 6, 0
PRINT "  tryck bara <ENTER> fr att g vidare."
PRINT
LINE INPUT L$
IF UCASE$(L$) = "L" THEN SYSTEM
END SUB

SUB NumDec (svar$)
'denna program hmtar in en storlek med siffervrde och enhet
'och delar upp det i ett mtetal och en enhetsstrng
LINE INPUT "Avls mtaren! (L fr Lmna) ", svar$
IF UCASE$(svar$) = "L" THEN SYSTEM
'ndrar komma till decimalpunkt och tar bort mellanslag
        NyDec$ = ""
                FOR num = 1 TO LEN(svar$)
                        char$ = MID$(svar$, num, 1)
                        IF char$ = "," THEN char$ = "."
                        IF char$ = " " THEN char$ = ""
                        NyDec$ = NyDec$ + char$
                NEXT num
        svarTal = VAL(NyDec$)
        svarenhet$ = ""
    DO
     FOR num = 1 TO LEN(NyDec$)
      IF ASC(MID$(NyDec$, num, 1)) < 58 AND ASC(MID$(NyDec$, num, 1)) > 47 THEN
          char$ = ""
       ELSEIF MID$(NyDec$, num, 1) = "." THEN
           char$ = ""
       ELSE char$ = MID$(NyDec$, num, 1)
      END IF
      svarenhet$ = svarenhet$ + char$
     NEXT num
      IF svarenhet$ = "" THEN
        PRINT "Ett mtvrde mste ha en enhet fr att vara meningsfull!"
        LINE INPUT "Vilken enhet ? ", NyDec$
       END IF
     LOOP UNTIL svarenhet$ <> ""
  PRINT "Ditt svar =  "; svarTal; " "; svarenhet$;
  IF svarenhet$ <> enhet$ THEN
       PRINT "  Du har inte skrivit enheten p samma stt !!"
    ELSE PRINT
  END IF
  END SUB

